#include <windows.h>
#include <gl/gl.h>
LRESULT CALLBACK WindowProc(HWND, UINT, WPARAM, LPARAM);
void EnableOpenGL(HWND hwnd, HDC*, HGLRC*);
void DisableOpenGL(HWND, HDC, HGLRC);
HDC hDC;
//========================== =============================
//INSERER MES VARIABLES GLOBALES ET MON CODE OPENGL ICI --
float theta = 0.0f;
void MonAffichageEnBoucle()
{
int i;
static GLfloat vertex[4][3] = {
{10, 10, 0},
{10, 0, 10},
{20, 0, 10},
{0, 0, 0}
};
static GLint faces[4][3] = {
{0,1,2},
{0,2,3},
{3,1,0},
{3,2,1}
};
/* OpenGL animation code goes here */
glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
glClear(GL_COLOR_BUFFER_BIT);
glPushMatrix();
glOrtho (-25.0, 25.0, -25.0, 25.0, -25.0, 25.0);
glRotatef(theta, 0.0f, 1.0f, 0.0f);
glPolygonMode( GL_FRONT_AND_BACK, GL_LINE );
//glPolygonMode( GL_FRONT_AND_BACK, GL_FILL );
for (i = 0; i < 4; i++) {
glBegin(GL_TRIANGLES);
glVertex3fv(&vertex [ faces[i][0] ] [0]);
glVertex3fv(&vertex [ faces[i][1] ] [0]);
glVertex3fv(&vertex [ faces[i][2] ] [0]);
glEnd();
}
glPopMatrix();
SwapBuffers(hDC);
theta += 1.0f;
Sleep (1);
}
// ========================== ===========================
int WINAPI WinMain( HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmd, int nCmdShow){
WNDCLASSEX wcex; HWND hwnd; HGLRC hRC; MSG msg; BOOL bQuit = FALSE;
wcex.cbSize = sizeof(WNDCLASSEX); wcex.style = CS_OWNDC;
wcex.lpfnWndProc = WindowProc; wcex.cbClsExtra = 0;
wcex.cbWndExtra = 0; wcex.hInstance = hInst;
wcex.hIcon = LoadIcon(NULL, IDI_APPLICATION);
wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
wcex.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
wcex.lpszMenuName = NULL; wcex.lpszClassName = "GLSample";
wcex.hIconSm = LoadIcon(NULL, IDI_APPLICATION);;
if (!RegisterClassEx(&wcex))return 0;
hwnd = CreateWindowEx(0, "GLSample", "OpenGL Sample",
WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT,
400, 400, NULL, NULL, hInst, NULL); ShowWindow(hwnd, nCmdShow);
EnableOpenGL(hwnd, &hDC, &hRC);
while (!bQuit){
if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)){
if (msg.message == WM_QUIT){bQuit = TRUE;}else
{TranslateMessage(&msg);DispatchMessage(&msg);}}
else {MonAffichageEnBoucle();}}
DisableOpenGL(hwnd, hDC, hRC);DestroyWindow(hwnd);return msg.wParam;
}
LRESULT CALLBACK WindowProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam){
switch (uMsg){
case WM_CLOSE:PostQuitMessage(0);break;
case WM_DESTROY:return 0;
case WM_KEYDOWN:{switch (wParam){case VK_ESCAPE:PostQuitMessage(0);break;}}break;
default:return DefWindowProc(hwnd, uMsg, wParam, lParam);}
return 0;
}
void EnableOpenGL(HWND hwnd, HDC* hDC, HGLRC* hRC){
PIXELFORMATDESCRIPTOR pfd;
int iFormat; *hDC = GetDC(hwnd); ZeroMemory(&pfd, sizeof(pfd));
pfd.nSize = sizeof(pfd); pfd.nVersion = 1;
pfd.dwFlags = PFD_DRAW_TO_WINDOW |PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER;
pfd.iPixelType = PFD_TYPE_RGBA; pfd.cColorBits = 24; pfd.cDepthBits = 16;
pfd.iLayerType = PFD_MAIN_PLANE;
iFormat = ChoosePixelFormat(*hDC, &pfd); SetPixelFormat(*hDC, iFormat, &pfd);
*hRC = wglCreateContext(*hDC); wglMakeCurrent(*hDC, *hRC);
}
void DisableOpenGL (HWND hwnd, HDC hDC, HGLRC hRC){
wglMakeCurrent(NULL, NULL); wglDeleteContext(hRC); ReleaseDC(hwnd, hDC);
}
